// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef CACHED_OBJ_H
#define CACHED_OBJ_H

#include "routeTree.h"
#include "error.h"

class routingNode;

class cachedObj{
 public:
  routingNode* rNode;
  routeTree rTree;
  int clearTree;
  int magicNum;

  cachedObj(){ rNode=0; magicNum=55880; clearTree=0; }
  ~cachedObj(){
    if(magicNum!=55880)
      ERROR("trying to double delete node here...");
    else
      magicNum=0;
  }

};

#endif
