// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

//Pipeline Aware Stuff
void routeNetQuickRoute(int iter, Net* net);
//void routePipelinedSinkQuickRoute(int iter, Net *net, Terminal *sinkTerminal, int latency);

bool findRouteQuickRoute(int iter, Net* net, priority_queue<pqNode>* PQ, list<pExplore> *cleanupList);
bool findRouteQuickRouteSink(int iter, Net* net, priority_queue<pqNode>* PQ, list<pExplore> *cleanupList, 
			     Terminal *sinkTerminal, int latency);

void addRoutingNodes2PQ(priority_queue<pqNode>* PQ, PipeliningNet* pNet, treeNode* tree_node, 
			int latency, vector <unsigned int> *basePathVector, list<pExplore> *cleanupList);

void backTracePipelinedRoute(Net* net, PipeliningNet* sourcePNet, Terminal* sinkTerminal, 
			     int lat, int e_index);

void btpr(pExplore *pNode);

void checkEmptyRRGraph(bool checkInPRTree);


