// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

//Timing-driven pipeline routing stuff
void routeNetQuickRoute_D(int iter, Net* net, double criticalPathDelay);
bool findRouteQuickRouteSink_D(int iter, Net* net, Terminal *sinkTerminal, int latency, priority_queue<pqNode>* PQ, 
			       list<pExplore> *cleanupList, double criticalPathDelay);

void addRoutingNodes2PQ_D(priority_queue<pqNode>* PQ, PipeliningNet* pNet, treeNode* tree_node, int assumed_crit_index, 
			  int latency, vector <unsigned int> *basePathVector, list<pExplore> *cleanupList, 
			  double criticalPathDelay);

void backTracePipelinedRoute_D(Net* net, PipeliningNet* sourcePNet, Terminal* sinkTerminal, 
			     int assumed_crit_index, int lat, int e_index, double criticalPathDelay);
