// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef UTIL_H
#define UTIL_H

std::string itoa(const int& x);

double doubmax(double x, double y);
double doubmin(double x, double y);
float flomax(float x, float y);
float flomin(float x, float y);

int min(int x, int y);
int max(int x, int y);
int KFUNCTION(int atLatency);
double convertACrit(int critIndex);
double calculateNewPathCost(double delay, double criticalPathDelay, double congestionCost, double additionalCosts);
double calculateNewPathCostAC(int ACIndex, double delay, double congestionCost, double additionalCosts);

class pipelineNet;
class Terminal;

class zipWidget{
 public:
  pipelineNet* pNet0;
  pipelineNet* pNet1;
};

class unZipWidget{
 public:
  pipelineNet* pNet0;
  pipelineNet* pNet1;
  Terminal* T0;
};

/* class cutCostDeltaWidget{ */
/*  public: */
/*   int cutID; */
/*   double cutCostDelta; */
/*   cutCostDeltaWidget(int ID, double delta){ */
/*     cutID = ID; */
/*     cutCostDelta = delta; */
/*   } */
/* }; */

#endif
