// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef PEXPLORE_H
#define PEXPLORE_H

class routingNode;

class pExplore{
 public:
  routingNode* rNode;
  int assumed_crit_index;
  int latency;
  int exploreIndex;

  pExplore(routingNode* r, int a_c_index, int lat, int e_index){
    rNode = r;
    assumed_crit_index = a_c_index;
    latency = lat;
    exploreIndex = e_index;
  }
  pExplore(){
    rNode = 0;
    assumed_crit_index = 0;
    latency = 0;
    exploreIndex = 0;
  }
  void clear(){
    rNode = 0;
    assumed_crit_index = 0;
    latency = 0;
    exploreIndex = 0;
  }
};

#endif
