// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

double calculateCrit(double slack, double criticalPathDelay);
double calculateCriticalPathDelay(Netlist *netlist, bool pipeline_aware);

void updatePQTimingDriven(priority_queue<pqNode>*,treeNode*,routingNode*, double);
void updatePQCongestionDriven(priority_queue<pqNode>*,treeNode*,routingNode*);
void initPQ(priority_queue<pqNode>&,treeNode*,routingNode*);

treeNode* backTrace(Net*,routingNode*, int);
treeNode* backTrace(PipeliningNet* pNet,routingNode* sink_rnode,int iter);
